#!/usr/bin/perl
# Web Site Cacher
#  By John Resig
#  <phytar@csh.rit.edu>

# URLs to cache hits from
my @urls = (
  'slashdot.org'
);

# Location of access logs
my $access = '/web/logs/www/access';

# Location to cache pages to
my $loc = '/web/sites/www/cache';

use strict;
use warnings;
use LWP::UserAgent;

my ( %cached );

my $ua = new LWP::UserAgent;
my $ujoin = join( '|', @urls );

open ( F, "tail -f $access |" );
while ( <F> ) {
  if ( /GET ([^\s]+) .*$ujoin/i ) {
    unless ( exists $cached{ $1 } ) {
      my $url = $1;
      my $dir = $1;
      $dir =~ s/^\///g;

      if ( $dir =~ s/\/([^\/]*)$//g ) {
        print "Caching $url\n";

        my $file = $1;
        $file = "index.html" if ( $file eq '' );
        $file =~ s/(php|cgi)$/html/i;

        chdir( $loc );

        foreach ( split( /\//, $dir ) ) {
          mkdir( $_ );
          chdir( $_ );
        }

	my $r = $ua->get( "http://www.csh.rit.edu$url" );
	my $data = $r->content();

	if ( $r->header( "Content-type" ) =~ /html/i ) {
	  $data =~ s/<\/head>/<base href="$dir"><\/head>/i ||
	    $data =~ s/<html>/<html><head><base href="$dir"><\/head>/i ||
	    ($data = "<html><head><base href='$dir'><\/head>" . $data . "</html>" );
        }

        open( O, ">$file" );
        print O $data;
        close( O );
  
        $cached{ $url } = 1;
      }
    }
  }
}
close ( F );
